﻿using HarmonyLib;
using UnityEngine;

public class MetalToScrap : Mod
{

    public void Start()
    {
        //Creates the Scrap Recipe
        Item_Base[] multipleItems = new Item_Base[] { ItemManager.GetItemByName("MetalIngot"), ItemManager.GetItemByName("Hinge"), ItemManager.GetItemByName("Bolt") };
        CreateRecipe(ItemManager.GetItemByName("Scrap"), 5, new CostMultiple(multipleItems, 1));

        //creates the MetalOre Recipe
        CreateRecipe(ItemManager.GetItemByName("MetalOre"), 1, new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Scrap") }, 5));

        Debug.Log("Mod MetalToScrap has been loaded!");
    }

    /// <summary>
    /// Function creating a new recipe setting with new recipe.
    /// </summary>
    /// <param name="pResultItem">Item resulting from the crafting.</param>
    /// <param name="pAmount">Crafting-Output Amount.</param>
    /// <param name="pCosts">Crafting costs.</param>
    public static void CreateRecipe(Item_Base pResultItem, int pAmount, params CostMultiple[] pCosts)
    {
        Traverse.Create(pResultItem.settings_recipe).Field("newCostToCraft").SetValue(pCosts);
        Traverse.Create(pResultItem.settings_recipe).Field("learned").SetValue(true);
        Traverse.Create(pResultItem.settings_recipe).Field("learnedFromBeginning").SetValue(true);
        Traverse.Create(pResultItem.settings_recipe).Field("craftingCategory").SetValue(CraftingCategory.Resources);
        Traverse.Create(pResultItem.settings_recipe).Field("amountToCraft").SetValue(pAmount);

    }

    public void OnModUnload()
    {
        Debug.Log("Mod MetalToScrap has been unloaded!");
        Destroy(gameObject);
    }
}